<?php

$base_dir = './';
include('error.php');
require('smtp_server_socket.php');

$end = false;

function sig_handler($signo)
{
	global $end;
	
	$end = true;
}

declare(ticks = 1);
pcntl_signal(SIGTERM, "sig_handler");
pcntl_signal(SIGINT,  "sig_handler");
pcntl_signal(SIGHUP,  "sig_handler");


echo "starting...\n";

$db = new Sql();

try {
	$sock = new SmtpServerSocket('192.168.0.3', 25, $db);
	
	while(!$end) {
		$sock->loop();
		usleep(100000);
	}
	
	echo "\nshutting down...\n";

	$sock->close();
} catch(Exception $e) {
	echo $e->getMessage()."\n";
}

$db->close();

?>