<?php

require('server_socket.php');
require('sql.php');

class SmtpServerSocket extends ServerSocket {
	var $serverName = '192.168.0.3';
	var $db = null;
	var $checkMX = false;
	
	function SmtpServerSocket($ip, $port, $db) {
		$this->ServerSocket($ip, $port);
		$this->db = $db;
	}
	
	function on_accept(&$config) {
		$s = $config['sock'];
		
		$msg = "220 smtp.example.com Nya!";
		echo "<== $msg\n";
		socket_write($s, $msg."\r\n");
		
		$config['buf'] = '';
		$config['datamode'] = false;
		$config['data'] = '';
		
		$config['host'] = '';
		$res = socket_getpeername($s, $host, $port);
		if(!$res) return;
		$config['host'] = $host;
	}
	
	function process(&$config) {
		$buf = $config['buf'];
		
		$pos = strpos($buf, "\r\n");
		if($pos===FALSE) return true;
		
		$a = explode("\r\n", $buf);
		$cmd = $a[0];
		$buf = substr($buf, strlen($cmd)+2);
		$config['buf'] = $buf;
		
		$full = $cmd;
		
		$a = explode(' ',$cmd);
		$cmd0 = $a[0];
		
		unset($a[0]);
		$params = explode(' ',implode(' ',$a));
		
		echo "==> $cmd\n";
		
		$res = $this->command($config, $cmd0, $params, $full);
		if($res===NULL) return false;
		
		if($res===true) return true;
		
		$debug = '';
		if(is_array($res)) {
			foreach($res as $r) {
				$debug.="<== $r\n";
			}
			$res = implode("\r\n", $res);
		} else $debug = $res;
		
		echo "<== $debug\n";
		
		$s = $config['sock'];
		socket_write($s, "$res\r\n");
		
		return true;
	}
	
	function command(&$config, $cmd, $params, $full) {
		if($config['datamode']) {
			if($full=='.') {
				$config['datamode'] = false;
				
				$to = implode("\n", $config['to']);
				
				$res = $this->db->insertInto("smtp", array(
					'from'=>$config['from'],
					'to'=>$to,
					'host'=>$config['host'],
					'recieved'=>date("Y-m-d H:i:s",time()),
					'data'=>$config['data']));
				
				if($res==true) return "250 Written safely to disk.";
				return "502 Command not implemented.";
			} else {
				$config['data'] .= $full."\r\n";
				return true;
			}
		}
		
		if($cmd=='HELO') {
			$host = '';
			if(isset($params[0])) $host = $params[0];
			return "250 Nya, $host!";
		}
		if($cmd=='MAIL') {
			$s = @$params[0];
			if(!$s) return "503 Bad sequence of commands.";
			
			$p1 = strpos($s, 'FROM:<');
			$p2 = strpos($s, '>');
			if(($p1===FALSE)||($p2===FALSE)) return "501 malformatted address";
			if($p1>=$p2) return "501 malformatted address";
			
			$a = explode('FROM:<', $s);
			$a = @$a[1];
			$a = explode('>', $a);
			$a = $a[0];
			
			if(!$this->isCorrectEmail($a, $this->checkMX)) return "501 incorrect e-mail";
			
			$config['from'] = $a;
			
			return "250 Ok";
		}
		if($cmd=='RCPT') {
			$s = @$params[0];
			if(!$s) return "503 Bad sequence of commands.";
			
			$from = @$config['from'];
			if(!$from) return "503 need MAIL before RCPT";
			
			$p1 = strpos($s, 'TO:<');
			$p2 = strpos($s, '>');
			if(($p1===FALSE)||($p2===FALSE)) return "501 malformatted address";
			if($p1>=$p2) return "501 malformatted address";
			
			$a = explode('TO:<', $s);
			$a = @$a[1];
			$a = explode('>', $a);
			$a = $a[0];
			
			if(!$this->isCorrectEmail($a, $this->checkMX)) return "501 incorrect e-mail";
			
			if(!isset($config['to'])) $config['to'] = array();
			$config['to'][] = $a;
			
			if(count($config['to'])>20) {
				return "452 too many recipients";
				$config['from'] = '';
			}
			
			return "250 Ok";
		}
		if($cmd=='DATA') {
			$to = @$config['to'];
			if(!$to) return "503 need RCPT before DATA";
			
			$config['datamode'] = true;
			
			return "354 End data with <CR><LF>.<CR><LF>";
		}
		if($cmd=='RSET') {
			return "250 Ok";
		}
		if($cmd=='QUIT') {
			$s = $config['sock'];
			echo "<== 221 Bye\n";
			socket_write($s, "221 Bye\r\n");
			return null;
		}
		return "502 Command not implemented.";
	}
	
	function isCorrectEmail($Email, $checkMX = false)
    {
		$result = array();
		
		#Use a regular expression to make sure the $Email string is in proper format
		#<username>@<domain>.<suffix> || <username>@<subnet>.<domain>.<suffix>
		if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$", $Email)) {
			return false;
		}
		
		if(!$checkMX) return true;
		
		list ($Username, $Domain) = split ("@", $Email); 
		
		#Verify the MX record. 
		if (getmxrr($Domain, $MXHost)) { 
			return true;
		}
		/*else { 
			#Establish a connection to the server.
			if (@fsockopen($Domain, 25, $errno, $errstr, 30)) {
				$result[0] = true;
				$result[1] = "$email appears to be valid.";
				return $result;
			} else  {
				$result[0] = false;
				$result[1] = "Cannot connect to the server.";
				return $result;
			}
		}*/
    }
}

?>